package com.ejie.ad74a.process;

import java.util.Arrays;
import java.util.Calendar;
import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.ejie.ad74a.exception.BatchProcessException;
import com.ejie.ad74a.model.Procesos;
import com.ejie.ad74a.service.ActualizacionExpedientesService;
import com.ejie.ad74a.service.ProcesosService;
import com.ejie.ad74a.util.UtilDates;
import com.ejie.ad74a.util.constantes.EstadosProcesosBatchEnum;
import com.ejie.ad74a.util.constantes.ProcesosBatchEnum;

/**
 * Proceso para realizar pruebas de ejecucion de codigo.
 */
@Component(value = "actExps")
public class ActualizarExpedientesProcess implements IProcess {

	private static final Logger logger = LoggerFactory.getLogger(ActualizarExpedientesProcess.class);
	
	@Autowired
	ProcesosService procesosService;
	
	@Autowired
	ActualizacionExpedientesService actualizacionExpedientesService;

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.ejie.ad74a.process.IProcess#execute(java.lang.String[])
	 */
	@Override
	public void execute(String... args) throws BatchProcessException {
		Procesos proceso = new Procesos();		
		try {
			
			String params = Arrays.asList(args).stream().map(i -> i).collect(Collectors.joining(", "));
			
			logger.debug("Params: {}", params);
			
			
			String idProceso = args.length == 1 ? args[1] : null;
			
			// Buscar si existe el proceso en bbdd
			boolean addProceso = false;
			if(idProceso == null || "".equals(idProceso)) {
				addProceso = true;
			} else {
				proceso = new Procesos(Long.valueOf(idProceso));
				proceso = this.procesosService.find(proceso);
				addProceso = null == proceso? true: false;					
			}	
			
			if(addProceso) {
				// Creamos un proceso nuevo
				// 1- Insertar el nuevo proceso en la tabla AD74A98T00
				Calendar calendar = Calendar.getInstance();
				calendar.setTime(UtilDates.getFechaSistema());
				proceso = new Procesos();
				proceso.setEstado98(EstadosProcesosBatchEnum.PENDIENTE.getId());
				proceso.setUsuAlta98("AD74A");				
				proceso.setTipoProceso98(ProcesosBatchEnum.ACT_EXPEDIENTES.getId());
				proceso.setProceso98(calendar.get(Calendar.YEAR) 
						+ "" + String.format("%02d" , (calendar.get(Calendar.MONTH) + 1)) 
						+ "" + String.format("%02d" , calendar.get(Calendar.DAY_OF_MONTH)) 
						);				
				proceso = this.procesosService.add(proceso);
			}
			
			this.procesosService.actualizarAIniciado(proceso);
			this.actualizacionExpedientesService.actualizarExpedientesX87B();
			this.procesosService.actualizarAFinalizado(proceso);	
			
		} catch (Exception e) {
			if(proceso != null && proceso.getIdProceso98() != null) {				
				proceso.setError98(e.getMessage().substring(0, Math.min(e.getMessage().length(), 799))); // Máximo 800
				this.procesosService.actualizarAError(proceso);
			}	
			throw new BatchProcessException(e);
		}
	}

}
